'use strict'

function _typeof(obj) {
	'@babel/helpers - typeof'
	if (typeof Symbol === 'function' && typeof Symbol.iterator === 'symbol') {
		_typeof = function _typeof(obj) {
			return typeof obj
		}
	} else {
		_typeof = function _typeof(obj) {
			return obj &&
				typeof Symbol === 'function' &&
				obj.constructor === Symbol &&
				obj !== Symbol.prototype
				? 'symbol'
				: typeof obj
		}
	}
	return _typeof(obj)
}

function _classCallCheck(instance, Constructor) {
	if (!(instance instanceof Constructor)) {
		throw new TypeError('Cannot call a class as a function')
	}
}

function _defineProperties(target, props) {
	for (var i = 0; i < props.length; i++) {
		var descriptor = props[i]
		descriptor.enumerable = descriptor.enumerable || false
		descriptor.configurable = true
		if ('value' in descriptor) descriptor.writable = true
		Object.defineProperty(target, descriptor.key, descriptor)
	}
}

function _createClass(Constructor, protoProps, staticProps) {
	if (protoProps) _defineProperties(Constructor.prototype, protoProps)
	if (staticProps) _defineProperties(Constructor, staticProps)
	return Constructor
}

module.exports = /*#__PURE__*/ (function () {
	function TieredMap(opts) {
		_classCallCheck(this, TieredMap)

		this.highestAttributes = {}
		this.attributesByTier = {}
		this.namedTiers = {}
		this.setTiers = []
		this.setConfig(opts)
	}

	_createClass(TieredMap, [
		{
			key: 'setConfig',
			value: function setConfig() {
				var opts =
					arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {}

				if (opts.onChangeListener) {
					this.onChangeListener = opts.onChangeListener
				}

				if (opts.namedTiers) {
					for (var key in opts.namedTiers) {
						if (opts.namedTiers.hasOwnProperty(opts.namedTiers)) {
							var value = opts.namedTiers[key]
							this.setTier(key, value)
						}
					}
				}

				return this
			},
		},
		{
			key: 'setTier',
			value: function setTier(key, value) {
				this.namedTiers[key] = value
				return this
			},
		},
		{
			key: 'getTier',
			value: function getTier(key) {
				var type = _typeof(key)

				if (type === 'number') {
					return key
				} else if (type === 'string') {
					return this.namedTiers[key]
				} else {
					throw new Error('Unknown type for key')
				}
			},
		},
		{
			key: 'getHighestTier',
			value: function getHighestTier() {
				return this.setTiers[this.setTiers.length - 1]
			},
		},
		{
			key: 'isHighestTier',
			value: function isHighestTier(tier) {
				return this.getTier(tier) === this.getHighestTier()
			},
		},
		{
			key: 'set',
			value: function set(key, value) {
				var tier =
					arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : 50
				tier = this.getTier(tier)

				if (tier < 0 || tier > 100) {
					throw new Error('Tier cannot be less than 0 or greater than 100')
				}

				var attributes = this.attributesByTier[tier]

				if (attributes == null) {
					attributes = this.attributesByTier[tier] = {}
					this.setTiers = [tier].concat(this.setTiers).sort()
				}

				attributes[key] = value
				var oldValue = this.highestAttributes[key]
				var newValue = this.getHighestValue(key)

				if (oldValue !== newValue) {
					this.highestAttributes[key] = newValue

					if (this.onChangeListener) {
						this.onChangeListener(key, newValue, oldValue)
					}
				}

				return this
			},
		},
		{
			key: 'get',
			value: function get(key, tier) {
				if (tier == null) {
					return this.highestAttributes[key]
				} else {
					return (this.attributesByTier[tier] || {})[key]
				}
			},
		},
		{
			key: 'getHighestValue',
			value: function getHighestValue(key) {
				var tiers = this.setTiers

				for (var i = tiers.length - 1; i >= 0; --i) {
					var tier = tiers[i]
					var value = this.get(key, tier)

					if (value != null) {
						return value
					}
				}
			},
		},
	])

	return TieredMap
})()
